HexTile = class("HexTile")


function HexTile:initialize(x,y)
self.x = x
self.y = y
self:generate()
end

function HexTile:generate()
-- Must fix this to be dynamic later
	if (self.x == 16) or (self.x == 1) or (self.y == 1) or (self.y == 16) then
		self.tileType = 0
		self.graphic = edgeHex
	else
		self.tileType = math.random(1,#hexTileType)
		self.graphic = hexTileType[self.tileType].hexGraphic
	end
end

function hexTileLoader()
	for n= #hexTileType,1,-1 do
		if love.filesystem.exists( "graphics/" .. hexTileType[n].graphicFolder ) then
			if love.filesystem.isDirectory( "graphics/" .. hexTileType[n].graphicFolder ) then
				checkFolderAssets(n)
			else
				Shiftup(hexTileType,n)
			end
		else
			Shiftup(hexTileType,n)
		end
	end
end

function checkFolderAssets(n)
	if love.filesystem.exists( "graphics/" .. hexTileType[n].graphicFolder .. "/hex.png" ) and
	love.filesystem.exists( "graphics/" .. hexTileType[n].graphicFolder .. "/floor.png" ) and
	love.filesystem.exists( "graphics/" .. hexTileType[n].graphicFolder .. "/wall.png" ) then
	hexTileType[n].hexGraphic = love.graphics.newImage("graphics/" .. hexTileType[n].graphicFolder .. "/hex.png" )
	else
		Shiftup(hexTileType,n)
	end
end
