Knight = class("Knight")

function Knight:initialize()
self.x = 1
self.y = 1
self.vision = 3
self.lastLocation = {}
	for n=1,8 do
		self.lastLocation[n] = {x=1,y=1}
	end
end

function Knight:draw(control)
	if control == true then
		love.graphics.draw(knightGraphic,320,320)
		love.graphics.draw(swordGraphic,320,320)
		love.graphics.draw(shieldGraphic,320,320)
	else
		love.graphics.draw(knightGraphic,320+(self.x-Game.Player.x)*32,320+(self.y-Game.Player.y)*32)
		love.graphics.draw(swordGraphic,320+(self.x-Game.Player.x)*32,320+(self.y-Game.Player.y)*32)
		love.graphics.draw(shieldGraphic,320+(self.x-Game.Player.x)*32,320+(self.y-Game.Player.y)*32)
	end
end

function Knight:moveAI()
local newX = self.x
local newY = self.y
	for n=-1,1 do
		for m=-1,1 do
			if exists(self.x+n,self.y+m,Game.LocalMap.Tile) then
				if Game.LocalMap.Tile[self.x+n][self.y+m].tileType ~= 2 then
					if Game.LocalMap.Tile[self.x+n][self.y+m].hasObject == false then
						if Game.LocalMap.Tile[self.x+n][self.y+m].value<Game.LocalMap.Tile[newX][newY].value then
							newX = self.x+n
							newY = self.y+m
						end
					end
				end
			end
		end
	end
	self:move(newX,newY)
end

function Knight:move(x,y)
	Shiftup(self.lastLocation,1)
	self.lastLocation[#self.lastLocation+1] = { 
	x = self.x,
	y = self.y}
	Game.LocalMap.Tile[self.x][self.y].hasObject = false
	self.x = x
	self.y = y	
	Game.LocalMap.Tile[self.x][self.y].hasObject = true
end