Player = class("Player")

function Player:initialize()
	-- super.initialize(self)
	self.control = "Knight"	
	self.Knight = Knight:new()
	self.Princess = Princess:new()
	self.vision = 3
	self.x = 1
	self.y = 1
end

function Player:update()

self:updateLocation()
self:updateVision()
end

function Player:draw()
	if self.control == "Knight" then
		self.Knight:draw(true)
		self.Princess:draw(false)
	else
		self.Knight:draw(false)
		self.Princess:draw(true)
	end
end

function Player:updateLocation()
	if self.control == "Knight" then
	
	self.Knight:move(self.x,self.y)
	self.Princess:moveAI()
	else
	self.Princess:move(self.x,self.y)
	self.Knight:moveAI()
	end
end

function Player:goTo(x,y)
self.Princess.x = x
self.Princess.y = y
self.Knight.x = x
self.Knight.y = y
Shiftup(self.Knight.lastLocation,1)
self.Knight.lastLocation[#self.Knight.lastLocation+1] = { 
x = self.Knight.x,
y = self.Knight.y}


self.Knight.x = x
self.Knight.y = y
	for n=-1,1 do
		for m=-1,1 do
			if m == 0 and n== 0 then
			break
			else
				if exists(x+n,y+m,Game.LocalMap.Tile) then
					if Game.LocalMap.Tile[x+n][y+m].tileType == 1 then
					self.Knight.x = x+n
					self.Knight.y = y+m
					end
				end
			end
		end
	end
self.x = self.Knight.x
self.y = self.Knight.y
end

function Player:move(x,y)
	if exists(self.x+x,self.y+y,Game.LocalMap.Tile) then
		if Game.LocalMap.Tile[self.x+x][self.y+y].tileType == 1 then
			if Game.LocalMap.Tile[self.x+x][self.y+y].hasObject == false then
				self.x = self.x+x
				self.y = self.y+y
				Game.turn = true
			end
		end
	end
	
end

function Player:updateVision()
	for n=-self.Knight.vision-1,self.Knight.vision+1 do
		for m=-self.Knight.vision-1,self.Knight.vision+1 do
			if exists(self.Knight.x+n,self.Knight.y+m,Game.LocalMap.Tile) then
				if Game.LocalMap.Tile[self.Knight.x+n][self.Knight.y+m].visibility == 255 then
					Game.LocalMap.Tile[self.Knight.x+n][self.Knight.y+m].visibility = 128
				end
			end
		end
	end
	for n=-self.Princess.vision-1,self.Princess.vision+1 do
		for m=-self.Princess.vision-1,self.Princess.vision+1 do
			if exists(self.Princess.x+n,self.Princess.y+m,Game.LocalMap.Tile) then
				if Game.LocalMap.Tile[self.Princess.x+n][self.Princess.y+m].visibility == 255 then
					Game.LocalMap.Tile[self.Princess.x+n][self.Princess.y+m].visibility = 128
				end
			end			 
		end
	end
-- self:LOS(self.x,self.y,self.vision)
self:LOS(self.Knight.x,self.Knight.y,self.Knight.vision)
self:LOS(self.Princess.x,self.Princess.y,self.Princess.vision)
end

function Player:LOS(x,y,distance)
local iter = 12
if distance == 4 then
iter = 12
elseif distance >4 then
iter = 6
else
iter = 22.5
end
	for i=0,360,iter do
		local dx=x+round(math.cos(i*0.01745)*distance,0)
		local dy=y+round(math.sin(i*0.01745)*distance,0)
		local tileArray = drawLine(x,y, dx, dy)
		if i>134 and i<293 then
			for n= #tileArray,1,-1 do
				if exists(tileArray[n].x,tileArray[n].y,Game.LocalMap.Tile) then
					if Game.LocalMap.Tile[tileArray[n].x][tileArray[n].y].tileType == 2 then
						Game.LocalMap.Tile[tileArray[n].x][tileArray[n].y].visibility = 255
						break
					else
						Game.LocalMap.Tile[tileArray[n].x][tileArray[n].y].visibility = 255
					end
				end
			end			
		else
			for n=1,#tileArray do
				if exists(tileArray[n].x,tileArray[n].y,Game.LocalMap.Tile) then
					if Game.LocalMap.Tile[tileArray[n].x][tileArray[n].y].tileType == 2 then
						Game.LocalMap.Tile[tileArray[n].x][tileArray[n].y].visibility = 255
						break
					else
						Game.LocalMap.Tile[tileArray[n].x][tileArray[n].y].visibility = 255
					end
				end
			end		
		end

	end
end






