
function mouseCollision(ax,ay,aw,ah)
if mx>ax and mx<(ax+aw) and my>ay and my<(ay+ah) then
return true
else
return false
end
end

function round(num, places)
 local mult = 10^(places)
 return math.floor(num * mult +.5) / mult
 end
 
 function Shiftup(tbl, loc)
	for n=loc,#tbl do
		tbl[n] = tbl[n+1]
	end
end

function distanceFrom(x1,y1,x2,y2)
   return math.sqrt((x2 - x1) ^ 2 + (y2 - y1) ^ 2)
end

-- Sort function
function sortInv(tbl,index,sortM,value)
        for k=1,table.getn(tbl)-1 do
			for j=1,table.getn(tbl)-k do
				if sortM(tbl[j].value,tbl[j+1].value) then
				   holder = tbl[j]
				   tbl[j] = tbl[j+1]
				   tbl[j+1] = holder
				end
			end
        end
end
--Sort types
function ascend (a,b)
	return a > b
end
function descend (a,b)
	return a < b
end

function exists(n,m,tbl)
	if tbl[n] ~= nil and tbl[n][m] ~= nil then
		return true
	else
		return false
	end	
end

function swap(a,b)
	local temp = b
	b = a
	a = temp
	return a, b
end

-- Bresenham's line algorithm
function drawLine(x0, y0, x1, y1)
	local lineArray = {}
	local steep = false
	if math.abs(y1 - y0) > math.abs(x1 - x0) then steep = true end
	if steep then
		x0, y0 = swap(x0, y0)
		x1, y1 = swap(x1, y1)
	end             
	 
	if x0 > x1 then
		x0, x1 = swap(x0, x1)
		y0, y1 = swap(y0, y1)
	end
	local deltax = x1 - x0
	local deltay = math.abs(y1 - y0)
	local err = deltax / 2
	local ystep = 0
	local y = y0
	if y0 < y1 then ystep = 1 else ystep = -1 end
	for x=x0,x1 do
		lineArray[#lineArray+1] = {}
	if steep then 
		lineArray[#lineArray].y = x
		lineArray[#lineArray].x = y
	 else 
		lineArray[#lineArray].x = x  
		lineArray[#lineArray].y = y           
	 end             
	 err = err - deltay
		 if err < 0 then
			 y = y + ystep
			 err = err + deltax
		end
	end
	return lineArray
end










